/************************************************************************/
/* $Id: MainP.cpp 65 2010-09-08 06:48:36Z yan.qi.asu $                                                                 */
/************************************************************************/

#include <limits>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <algorithm>
#include "GraphElements.h"
#include "Graph.h"
#include "DijkstraShortestPathAlg.h"
#include "YenTopKShortestPathsAlg.h"

using namespace std;



void testDijkstraGraph()
{
	Graph* my_graph_pt = new Graph("data/test_1");
	DijkstraShortestPathAlg shortest_path_alg(my_graph_pt);
	BasePath* result = 
		shortest_path_alg.get_shortest_path(
			my_graph_pt->get_vertex(0), my_graph_pt->get_vertex(5));
	result->PrintOut(cout);
}

void testYenAlg( const int& k, 
	             link* lk, 
				 const int& size,
				 const int& s,
				 const int& d,
				 const int& nodes )
{
	Graph my_graph;

	my_graph.set_number_vertices( nodes );

	for ( int i = 0; i < size; i++ )
	{
		my_graph.add_link( lk[ i ].u, lk[ i ].v, lk[ i ].weight );
	}	

	my_graph.setv();
	
	YenTopKShortestPathsAlg yenAlg(my_graph, 
		                           my_graph.get_vertex(s), 
		                           my_graph.get_vertex(d) );

	// Output the k-shortest paths
	int i = 0;
	while( yenAlg.has_next() && i < k )
	{
		++i;
		yenAlg.next()->PrintOut(cout);
	}
}


int main(...)
{
	link lks[] = {  {0, 1},
					{0, 12},
					{0, 13},
					{1, 0},
					{1, 2},
					{2, 1},
					{2, 3},
					{2, 5},
					{3, 2},
					{3, 4},
					{4, 3},
					{4, 5},
					{4, 6},
					{5, 2},
					{5, 4},
					{5, 7},
					{6, 4},
					{6, 8},
					{7, 5},
					{7, 10},
					{8, 6},
					{8, 10},
					{9, 8},
					{9, 11},
					{10, 7},
					{10, 8},
					{10, 11},
					{11, 9},
					{11, 10},
					{11, 12},
					{11, 13},
					{12, 11},
					{13, 11},
					{13, 14},
					{14, 1},
					{14, 5},
					{14, 13} };
	
	int k = 5;
	int array_size = sizeof( lks ) / sizeof( lks[ 0 ] );
	int start = 1;
	int end = 8;
	int nodes = 15;


	testYenAlg( k, 
		        lks, 
				array_size, 
				start,
				end, 
				nodes );
}
